<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 Robert Heel <rheel@1drop.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Ajax mail subscription' for the 'ods_ajaxmailsubscription' extension.
 *
 * @author	Robert Heel <rheel@1drop.de>
 * @package	TYPO3
 * @subpackage	tx_odsajaxmailsubscription
 */
class tx_odsajaxmailsubscription_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_odsajaxmailsubscription_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_odsajaxmailsubscription_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'ods_ajaxmailsubscription';	// The extension key.

	var $user; // user information
	var $config; // Configuration
	var $error; // Errors
	var $info; // Infomessage
	var $hooks;
	var $htmlMail; // htmlMail object
	var $prefs=array('gender','first_name','middle_name','last_name','birthday','title','phone','mobile','www','address','building','room','company','city','zip','region','country','fax');
	var $tables=array('t'=>'tt_address','f'=>'fe_users');
	var $tables_mm=array(
		'sys_dmail_group'=>array('MM'=>'sys_dmail_group_mm','user_local'=>false,'tablename'=>true),
		'sys_dmail_category'=>array('MM'=>'sys_dmail_ttaddress_category_mm','user_local'=>true),
	);

	var $template; // Temlates

	function init($conf){
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin
		$this->pi_USER_INT_obj=1; // Make the plugin not cachable

		$this->hooks=array();
		if(is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey][$this->scriptRelPath])){
			foreach($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey][$this->scriptRelPath] as $classRef){
				$this->hooks[]=&t3lib_div::getUserObj($classRef);
			}
		}

		/* --------------------------------------------------
			Configuration (order of priority)
			- FlexForm
			- TypoScript
		-------------------------------------------------- */

		$flex=array();
		$options=array(
			'default_group'=>'sDEF',
			'default_type'=>'sDEF',
			'mail_from'=>'sDEF',
			'mail_notify'=>'sDEF',
			'mail_reply'=>'sDEF',
			'mail_return'=>'sDEF',
			'page_edit'=>'sDEF',
			'page_redirect_unsubscribe'=>'sDEF',
			'show_default'=>'sDEF',
			'template'=>'sDEF',
			'mail_subscribe_subject'=>'sheet_text',
			'mail_subscribe_body'=>'sheet_text',
			'mail_unsubscribe_subject'=>'sheet_text',
			'mail_unsubscribe_body'=>'sheet_text',
		);
		foreach($options as $option=>$sheet){
			$value=$this->pi_getFFvalue($this->cObj->data['pi_flexform'],$option,$sheet);
			if($value){
				switch($option){
					case 'template':
						$flex[$option]='uploads/tx_odsajaxmailsubscription/'.$value;
					break;
					default:
						$flex[$option]=$value;
					break;
				}
			}
		}
		$this->config=array_merge($conf,$flex);

		if($this->cObj->data['pages']) $this->config['page_records']=$this->cObj->data['pages'];
		if($this->cObj->data['recursive']) $this->config['page_records_recursive']=$this->cObj->data['recursive'];

		$this->config['mail_from']=strtr($this->config['mail_from'],array('###DOMAIN###'=>$_SERVER['HTTP_HOST']));
		if(empty($this->config['page_edit'])) $this->config['page_edit']=$GLOBALS['TSFE']->id;

		// Backward compatibility to 0.2.x
		if(is_numeric($this->config['default_group'])) $this->config['default_group']='sys_dmail_group_'.$this->config['default_group'];
	}

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->init($conf);

		$this->htmlMail=t3lib_div::makeInstance('t3lib_htmlmail');
		$this->htmlMail->from_email=$this->config['mail_from'];
		$this->htmlMail->replyto_email=$this->config['mail_reply'];
		$this->htmlMail->returnPath=$this->config['mail_return'];

		/**
			* Instantiate the xajax object and configure it
			*/
		// Include xaJax
		require_once (t3lib_extMgm::extPath('xajax') . 'class.tx_xajax.php');
		// Make the instance
		$this->xajax = t3lib_div::makeInstance('tx_xajax');
		// nothing to set, we send to the same URI
		# $this->xajax->setRequestURI('xxx');
		// Decode form vars from utf8 ???
		$this->xajax->decodeUTF8InputOn();
		// Encode of the response to utf-8 ???
		$this->xajax->setCharEncoding('utf-8');
		// Do you wnat messages in the status bar?
		$this->xajax->statusMessagesOn();
		// Turn only on during testing
		# $this->xajax->debugOn();
		// Register the names of the PHP functions you want to be able to call through xajax
		// $xajax->registerFunction(array('functionNameInJavascript', &$object, 'methodName'));
		$this->xajax->registerFunction(array('processSubscription', &$this, 'processSubscription'));
		// If this is an xajax request, call our registered function, send output and exit
		if($_POST['xajax']=='processSubscription') $this->xajax->processRequests();
		// Else create javascript and add it to the header output
		if(method_exists($this->xajax,'getJavascriptFunctions')){
			$GLOBALS['TSFE']->additionalHeaderData['xajax'] = $this->xajax->getJavascriptConfig().$this->xajax->getJavascriptInclude(t3lib_extMgm::siteRelPath('xajax'));
			$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId] = $this->xajax->getJavascriptFunctions();
		}else{
			$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId] = $this->xajax->getJavascript(t3lib_extMgm::siteRelPath('xajax'));
		}

		$this->processInput();
		$this->loadTemplate();
		$subpart['###ERROR###']='<div id="'.$this->prefixId.'_error">'.$this->getError().'</div>';
		$subpart['###SUBSCRIBE###']='<div id="'.$this->prefixId.'_subscribe">'.$this->getSubscribe().'</div>';
		$subpart['###UNSUBSCRIBE###']='<div id="'.$this->prefixId.'_unsubscribe">'.$this->getUnsubscribe().'</div>';
		$subpart['###INFO###']='<div id="'.$this->prefixId.'_info">'.$this->getInfo().'</div>';
		$subpart['###PREFS###']='<div id="'.$this->prefixId.'_prefs">'.$this->getPrefs().'</div>';
		$subpart['###INDICATION###']='<div id="'.$this->prefixId.'_indication" style="display: none;">'.$this->getIndication().'</div>';
		$content.=$this->cObj->substituteMarkerArrayCached($this->template['total'],array(),$subpart);

		return $this->pi_wrapInBaseClass($content);
	}

	function loadTemplate(){
		$templateCode=$this->cObj->fileResource($this->config['template']);
		if(empty($templateCode)){
			$templateCode=$this->cObj->fileResource('EXT:'.$this->extKey.'/pi1/ajaxmailsubscription.tmpl');
		}
		$this->template['total']=$this->cObj->getSubpart($templateCode,'###AJAXMAILSUBSCRIPTION###');
	}

	function processInput(){
		/* --------------------------------------------------
			Subscribe (submit)
		-------------------------------------------------- */
		if($this->piVars['submit']){
			$email=trim($this->piVars['email']);
			if(t3lib_div::validEmail($email) && $email!=$this->pi_getLL('default_mail')){

				// Search address
				$user=$this->searchAddress(array('email'=>$email));
				if(!$user && $this->config['default_table']){
					// Create new address
					$table=$this->config['default_table'];
					$user=array(
						'pid'=>intval(strtok($this->config['page_records'],',')),
						'tstamp'=>time(),
						$GLOBALS['TCA'][$table]['ctrl']['enablecolumns']['disabled']=>1,
						'email'=>$email,
						'module_sys_dmail_html'=>$this->config['default_type'],
					);
					$user=array_merge($user,$this->getPrefsUpdate($table));
					$res=$GLOBALS['TYPO3_DB']->exec_INSERTquery($table,$user);
					$user['uid']=$GLOBALS['TYPO3_DB']->sql_insert_id();
					$user['table']=$table;
					// log
					$log=$user;
					$log['action']='create';
					$this->logging($log);
				}

				if($user){
					// Create link
					$header='From: '.$this->config['mail_from']."\n".'Return-path: '.$this->config['mail_from'];
					$server=t3lib_div::getIndpEnv('HTTP_HOST');
					$link=t3lib_div::locationHeaderUrl($this->pi_getPageLink($this->config['page_edit'],'',array('t'=>$user['table'],'u'=>$user['uid'],'a'=>t3lib_div::stdAuthCode($user,$this->config['authcode_fields']))));

					// Is user registered?
					if($user[$GLOBALS['TCA'][$user['table']]['ctrl']['enablecolumns']['disabled']]){
						// Create message
						$this->info=$this->pi_getLL('info_new');
						$subject=sprintf($this->pi_getLL('mail_new_subject'),$server);
						$text=sprintf($this->pi_getLL('mail_new_body'),$link);
					}else{
						// Inform user
						$this->info=$this->pi_getLL('info_change');
						$subject=sprintf($this->pi_getLL('mail_change_subject'),$server);
						$text=sprintf($this->pi_getLL('mail_change_body'),$link);
					}
					// Send email
					$this->sendMail($email,$subject,$text);
					// Notify user
					$this->info.='<br />'.$this->pi_getLL('check_mail');
				}else{
					$this->error=$this->pi_getLL('mail_invalid');
				}
			}else{
				$this->error=$this->pi_getLL('mail_invalid');
			}
		}elseif($this->config['show_default']){
			$this->piVars['email']=$this->pi_getLL('default_mail');
		}

		/* --------------------------------------------------
			Confirmation (rid)
		-------------------------------------------------- */
		if($_GET['t'] && array_key_exists(substr($_GET['t'],0,1),$this->tables) && $_GET['u'] && $_GET['a']){
			$user=$this->searchWhere(array('uid'=>$_GET['u']),$this->tables[substr($_GET['t'],0,1)]);
			if($user){
				if($_GET['a']==t3lib_div::stdAuthCode($user,$this->config['authcode_fields'])){
					if($user[$GLOBALS['TCA'][$user['table']]['ctrl']['enablecolumns']['disabled']]){
						$GLOBALS['TYPO3_DB']->exec_UPDATEquery($user['table'],'uid='.$user['uid'],array($GLOBALS['TCA'][$user['table']]['ctrl']['enablecolumns']['disabled']=>0));
						$this->joinList($user,$this->config['default_group']);
						$this->info=$this->pi_getLL('activated');
						// Send email
						if(!empty($this->config['mail_subscribe_subject'])){
							$this->sendMail($user['email'],$this->config['mail_subscribe_subject'],$this->config['mail_subscribe_body']);
						}
						// log
						$log=$user;
						$log['action']='subscribe';
						$this->logging($log);
					}
					$GLOBALS['TSFE']->fe_user->setKey('ses','address',$user);
				}
			}
		}

		$this->user=$GLOBALS['TSFE']->fe_user->getKey('ses','address');

		/* --------------------------------------------------
			Preferences
		-------------------------------------------------- */
		if($this->piVars['prefs'] && $this->user){
			$update=$this->getPrefsUpdate($this->user['table']);
			$res=$GLOBALS['TYPO3_DB']->exec_UPDATEquery($this->user['table'],'uid='.$this->user['uid'],$update);
			if($res){
				$this->info=$this->pi_getLL('update_success');
			}else{
				$this->info=$this->pi_getLL('update_fail');
			}
		}

		/* --------------------------------------------------
			Unsubscribe
		-------------------------------------------------- */
		if($_GET['action']=='delete' && $this->user){
			// Unsubscribe user
			$this->leaveList($this->user);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery($this->user['table'],'uid='.$this->user['uid'],array($GLOBALS['TCA'][$this->user['table']]['ctrl']['enablecolumns']['disabled']=>1));
			// Send email
			if(!empty($this->config['mail_unsubscribe_subject'])){
				$this->sendMail($this->user['email'],$this->config['mail_unsubscribe_subject'],$this->config['mail_unsubscribe_body']);
			}
			// Redirect
			if($this->config['page_redirect_unsubscribe']){
				header('Location: '.t3lib_div::locationHeaderUrl($this->pi_getPageLink($this->config['page_redirect_unsubscribe'])));
			}
			// log
			$log=$this->user;
			$log['action']='unsubscribe';
			$this->logging($log);
			// Delete session
			$GLOBALS['TSFE']->fe_user->setKey('ses','address',NULL);
			$this->user=NULL;
		}
	}

	function joinList($user,$group){
		$lists=$this->splitGroup($group);
		foreach($lists as $list=>$items){
			if(array_key_exists($list,$this->tables_mm)){
				foreach($items as $item){
					if($this->tables_mm[$list]['user_local']){
						$insert=array(
							'uid_local'=>$user['uid'],
							'uid_foreign'=>$item,
						);
					}else{
						$insert=array(
							'uid_local'=>$item,
							'uid_foreign'=>$user['uid'],
						);
					}
					if($this->tables_mm[$list]['tablename']) $insert['tablenames']=$user['table'];
					$res=$GLOBALS['TYPO3_DB']->exec_INSERTquery($this->tables_mm[$list]['MM'],$insert);
				}
			}
		}
	}

	function leaveList($user){
		foreach($this->tables_mm as $list=>$conf){
			if($conf['user_local']){
				$where='uid_local='.$user['uid'];
			}else{
				$where='uid_foreign='.$user['uid'];
			}
			$GLOBALS['TYPO3_DB']->exec_DELETEquery($conf['MM'],$where.' AND (tablenames="'.$user['table'].'" OR tablenames="")');
		}
	}

	function splitGroup($group){
		$groups=explode(',',$group);
		foreach($groups as $group){
			$item=t3lib_div::revExplode('_',$group,2);
			$ret[$item[0]][]=$item[1];
		}
		return($ret);
	}

	function logging($data){
		// Syslog entry
		$insert=array(
			'tablename'=>'sys_dmail_group_mm',
//			'details'=>t3lib_div::arrayToLogString($data),
			'details'=>'%s address %s (table: %s, uid: %s, list %s)',
			'tstamp'=>time(),
			'IP'=>t3lib_div::getIndpEnv('REMOTE_ADDR'),
			'log_data'=>serialize(array($data['action'],$data['email'],$data['table'],$data['uid'],$this->config['default_group'])),
			'event_pid'=>0,
		);
		$res=$GLOBALS['TYPO3_DB']->exec_INSERTquery('sys_log',$insert);
		// Notify mail
		if($this->config['mail_notify']){
			$this->sendMail(
				$this->config['mail_notify'],
				sprintf($this->pi_getLL('mail_notify_subject'),$data['email'],$this->pi_getLL('mail_notify_'.$data['action']),$data['table'],$data['uid']),
				sprintf($this->pi_getLL('mail_notify_body'),$data['email'],$this->pi_getLL('mail_notify_'.$data['action']),$data['table'],$data['uid'])
			);
		}
	}

	function searchAddress($where){
		$ret=false;
		foreach($this->tables as $table){
			$row=$this->searchWhere($where,$table);
			if($row){
				$ret=$row;
				break;
			}
		}
		return($ret);
	}

	function searchWhere($where,$table){
		foreach($where as $field=>$value){
			$sql.=' AND '.$field.'='.$GLOBALS['TYPO3_DB']->fullQuoteStr($value,$table);
		}
		$pidList=$this->pi_getPidList($this->config['page_records'],intval($this->config['page_records_recursive']));
		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*',$table,'pid IN ('.$pidList.') AND deleted=0'.$sql,'','',1);
		$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
		if($row){
			$row['table']=$table;
		}
		return($row);
	}

	function getError(){
		if($this->error){
			$template['error']=$this->cObj->getSubpart($this->template['total'],'###ERROR###');
			$marker['###ERRORMSG###']=$this->error;
			$ret=$this->cObj->substituteMarkerArrayCached($template['error'],$marker);
		}else{
			$ret='';
		}
		return($ret);
	}

	function getSubscribe(){
		if(!$this->user && !$this->info){
			$template['subscribe']=$this->cObj->getSubpart($this->template['total'],'###SUBSCRIBE###');
			$marker=$this->getPrefsOptions();
			$marker['###SUBSCRIBE_TEXT###']=$this->pi_getLL('text_subscribe');
			$marker['###EMAIL_NAME###']=$this->prefixId.'[email]';
			$marker['###EMAIL_VALUE###']=$this->piVars['email'];
			$marker['###FORM_ID###']=$this->prefixId.'_form';
			$marker['###FORM_ONSUBMIT###']='return false;';
			// Start loading indication
			$marker['###SUBMIT_ONCLICK###']="xajax.$('".$this->prefixId."_indication').style.display='block';";
			// submit should call xajax instead.
			$marker['###SUBMIT_ONCLICK###'].='xajax_processSubscription(xajax.getFormValues(\''.$this->prefixId.'_form\'))';
			$marker['###SUBMIT_NAME###']=$this->prefixId.'[submit]';
			$marker['###SUBMIT_VALUE###']=$this->pi_getLL('subscribe');
			return($this->cObj->substituteMarkerArrayCached($template['subscribe'],$marker));
		}
	}

	function getUnsubscribe(){
		// TODO: Merge unsubscribe and prefs
		if($this->user){
			$template['unsubscribe']=$this->cObj->getSubpart($this->template['total'],'###UNSUBSCRIBE###');
			$marker['###UNSUBSCRIBE_TEXT###']=$this->pi_getLL('text_unsubscribe');
			// edit
			$marker['###EDIT_LINK###']=$this->pi_getPageLink($this->config['page_edit']);
			$marker['###EDIT_TEXT###']=$this->pi_getLL('page_edit');
			// unsubscribe
			$marker['###LINK###']=$this->pi_getPageLink($GLOBALS['TSFE']->id,'',array('action'=>'delete'));
			$marker['###ONCLICK###']="return window.confirm('".$this->pi_getLL('sure')."');";
			$marker['###TEXT###']=$this->pi_getLL('unsubscribe');

			// Hook to change marker
			foreach($this->hooks as $hook){
				if(method_exists($hook,'unsubscribeMarker')){
					$hook->unsubscribeMarker($marker,$this);
				}
			}

			return($this->cObj->substituteMarkerArrayCached($template['unsubscribe'],$marker));
		}
	}

	function getInfo(){
		if($this->info){
			$template['info']=$this->cObj->getSubpart($this->template['total'],'###INFO###');
			$marker['###INFOMSG###']=$this->info;
			$ret=$this->cObj->substituteMarkerArrayCached($template['info'],$marker);
		}else{
			$ret='';
		}
		return($ret);
	}

	function getPrefs(){
		if($this->user){
			$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('*',$this->user['table'],'deleted=0 AND uid='.$this->user['uid'],'','',1);
			if($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
				$template['prefs']=$this->cObj->getSubpart($this->template['total'],'###PREFS###');
				$marker=$this->getPrefsOptions($row);
				$marker['###PREFS_TEXT###']=$this->pi_getLL('text_prefs');
				// Form and submit
				$marker['###FORM_ID###']=$this->prefixId.'_prefform';
				$marker['###FORM_ONSUBMIT###']='return false;';
				$marker['###SUBMIT_NAME###']=$this->prefixId.'[prefs]';
				// Start loading indication
				$marker['###SUBMIT_ONCLICK###']="xajax.$('".$this->prefixId."_indication').style.display='block';";
				// submit should call xajax instead.
				$marker['###SUBMIT_ONCLICK###'].='xajax_processSubscription(xajax.getFormValues(\''.$this->prefixId.'_prefform\'))';
				$marker['###SUBMIT_VALUE###']=$this->pi_getLL('update');
				return($this->cObj->substituteMarkerArrayCached($template['prefs'],$marker));
			}else{
				$this->user=false;
			}
		}
	}

	function getPrefsOptions($default=array()){
		// Input fields
		foreach($this->prefs as $pref){
			$marker['###'.strtoupper($pref).'_DESC###']=$this->pi_getLL('desc_'.$pref);
			$marker['###'.strtoupper($pref).'_NAME###']=$this->prefixId.'['.$pref.']';
			$marker['###'.strtoupper($pref).'_VALUE###']=$default[$pref];
		}
		// Gender select
		foreach(array('m','f') as $val){
			$marker['###GENDER_OPTIONS###'].='<option value="'.$val.'"';
			if($val==$default['gender']) $marker['###GENDER_OPTIONS###'].=' selected="selected"';
			$marker['###GENDER_OPTIONS###'].='>'.$this->pi_getLL('desc_gender.'.$val).'</option>';
		}
		return($marker);
	}
	
	function getPrefsUpdate($table){
		$update=array();
		foreach($this->prefs as $pref){
			if(isset($this->piVars[$pref])) $update[$pref]=$this->piVars[$pref];
		}
		// Update tt_address name field
		if($table=='tt_address' && ($update['first_name'] || $update['middle_name'] || $update['last_name'])){
			$tt_address=unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['tt_address']);
			$name=sprintf(
				$tt_address['backwardsCompatFormat'],
				$update['first_name'],
				$update['middle_name'],
				$update['last_name']
			);
			if(!empty($name)) {
				$update['name']=$name;
			}
		}
		return($update);
	}

	function getIndication(){
		/* --------------------------------------------------
			Loading indication
		-------------------------------------------------- */
		$template['indication']=$this->cObj->getSubpart($this->template['total'],'###INDICATION###');
		$ret=$template['indication'];
		return($ret);
	}

	function processSubscription($data){
		// We put our incoming data to the regular piVars
		$this->piVars=$data[$this->prefixId];
		// Instantiate the tx_xajax_response object
		$objResponse = new tx_xajax_response();
		// Add the content to or result box
		$this->processInput();
		$this->loadTemplate();
		$objResponse->addAssign($this->prefixId.'_error','innerHTML',$this->getError());
		if(!$this->getSubscribe()) $objResponse->addClear($this->prefixId.'_subscribe','innerHTML');
		$objResponse->addAssign($this->prefixId.'_unsubscribe','innerHTML',$this->getUnsubscribe());
		$objResponse->addAssign($this->prefixId.'_info','innerHTML',$this->getInfo());
		if(!$this->getPrefs()) $objResponse->addClear($this->prefixId.'_prefs','innerHTML');
		$objResponse->script('xajax.$("'.$this->prefixId.'_indication").style.display="none"');
		//return the XML response
		return($objResponse->getXML());
	}

	function sendMail($recipient,$subject,$plaintext){
		$this->htmlMail->start();
		$this->htmlMail->recipient=$recipient;
		$this->htmlMail->subject=$subject;
		$this->htmlMail->addPlain($plaintext);
//		$this->htmlMail->setHTML($this->htmlMail->encodeMsg('<html><body>'.$text.'</body></html>'));
		$this->htmlMail->send('');
//		t3lib_div::plainMailEncoded($email,$subject,$text,$header);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ods_ajaxmailsubscription/pi1/class.tx_odsajaxmailsubscription_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ods_ajaxmailsubscription/pi1/class.tx_odsajaxmailsubscription_pi1.php']);
}

?>
